Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/ScenarioParser.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/ScenarioParser.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/ScenarioParser.cs	(revision 8958)
@@ -0,0 +1,264 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.IO;
+using System.Xml;
+using System.Globalization;
+using System.Xml.Linq;
+using HeuristicLab.Services.Optimization.ControllerService.Azure;
+using HeuristicLab.Services.Optimization.ControllerService.Interfaces;
+
+namespace HeuristicLab.Services.Optimization.ControllerService {
+  public class ScenarioParser {
+    private static IList<Model.OptimizationScenario> scenarios;
+    private static object lockable = new object();
+
+    private IDataAccessLayer dal = new AzureDataAccessLayer();
+
+    public IList<Model.OptimizationScenario> Scenarios {
+      get {
+        if (scenarios == null) {
+          lock (lockable) {
+            if (scenarios == null) {
+              ParseScenarios();
+            }
+          }
+        }
+        return scenarios;
+      }
+    }
+    
+    public Model.OptimizationScenario GetByName(string name) {
+      foreach (var scen in Scenarios) {
+        if (scen.Name == name) {
+          return scen;
+        }
+      }
+      return null;
+    }
+
+    /*// http://www.sascha-dittmann.de/post/Webseitenpfade-einer-Windows-Azure-Web-Rolle-bestimmen.aspx
+    private static IEnumerable<string> WebSiteDirectories {
+      get {
+        var roleRootDir = Environment.GetEnvironmentVariable("RdRoleRoot");
+        if (roleRootDir == null)
+          return Enumerable.Empty<string>();
+        XNamespace roleModelNs =
+          "http://schemas.microsoft.com/ServiceHosting/2008/10/ServiceDefinition";
+        var roleModelDoc = XDocument.Load(Path.Combine(roleRootDir, "RoleModel.xml"));
+        if (roleModelDoc.Root == null)
+          return Enumerable.Empty<string>();
+
+        var sites = roleModelDoc.Root.Element(roleModelNs + "Sites");
+        if (sites == null)
+          return Enumerable.Empty<string>();
+
+        var siteElements = sites.Elements(roleModelNs + "Site");
+
+        return
+          from siteElement in siteElements
+          where siteElement.Attribute("name") != null
+                && siteElement.Attribute("name").Value == "Web"
+                && siteElement.Attribute("physicalDirectory") != null
+          select Path.Combine(roleRootDir,
+                 siteElement.Attribute("physicalDirectory").Value);
+      }
+    }
+     */
+
+    private void ParseScenarios() {
+      var scens = new List<Model.OptimizationScenario>();
+      /*string path;
+      if (WebSiteDirectories.Count() != 0) {
+        path = WebSiteDirectories.FirstOrDefault() + @"\Mappings";
+      } else {
+        path = AppDomain.CurrentDomain.BaseDirectory + @"\Mappings";
+      }
+        
+      foreach (var file in Directory.EnumerateFiles(path, "*.xml")) {
+        var scenario = ParseScenarioFromFile(file);
+        if (scenario != null)
+          scens.Add(scenario);
+      }*/
+
+      var scenarioDao = dal.CreateScenarioDao();
+      var blobDao = dal.CreateBlobDao();
+      foreach (var entity in scenarioDao.GetAllEntities()) {
+        var scenarioXml = blobDao.FindByKey(entity.Scenario).Text;
+        var scenario = ParseScenarioFromXml(scenarioXml);
+        if (scenario != null)
+          scens.Add(scenario);
+      }
+
+      scenarios = scens;
+    }
+
+    private XmlReaderSettings GetSettings() {
+      // Set the validation settings.
+      XmlReaderSettings settings = new XmlReaderSettings();
+      settings.ValidationType = ValidationType.Schema;
+      settings.Schemas.Add("urn:scenario-schema", AppDomain.CurrentDomain.BaseDirectory + @"\Mappings\scenario.xsd");      
+      return settings;
+    }
+
+    public Model.OptimizationScenario ParseScenarioFromXml(string xml) {
+      //using (var reader = XmlReader.Create(new StringReader(xml), GetSettings())) {
+        return ParseScenario(new StringReader(xml));
+      //}            
+    }
+
+   /* private Model.OptimizationScenario ParseScenarioFromFile(string filename) {
+      using (var reader = XmlReader.Create(new FileStream(filename, FileMode.Open), GetSettings())) {
+        return ParseScenario(reader);
+      }      
+    } */
+
+    private Model.OptimizationScenario ParseScenario(StringReader str) {
+      // Set the validation settings.      
+      bool isErrorPresent = false;
+      var settings = GetSettings();
+      settings.ValidationEventHandler += (sender, args) => {
+        Console.WriteLine(args.Message);
+        isErrorPresent = true;
+      };
+      Model.OptimizationScenario scenario = null;
+      using (var reader = XmlReader.Create(str, settings)) {        
+        while (!isErrorPresent && !reader.EOF) {
+          if (reader.Name == "scenario" && reader.NodeType == XmlNodeType.Element) {
+            scenario = new Model.OptimizationScenario();
+            scenario.ProblemType = reader.GetAttribute("mapper");
+            scenario.ProblemType = reader.GetAttribute("algorithmType");
+            scenario.ProblemType = reader.GetAttribute("problemType");
+          }
+          else if (reader.Name == "name") {
+            scenario.Name = reader.ReadElementContentAsString();
+            continue;
+          }
+          else if (reader.Name == "problemParameters") {
+            IList<Model.Parameter> problemParameters = ParseParameters(reader);
+            foreach (var param in problemParameters)
+              scenario.InputParameters.Items.Add(param);
+          }
+          else if (reader.Name == "algorithmParameters") {
+            IList<Model.Parameter> algoParameters = ParseParameters(reader);
+            foreach (var param in algoParameters)
+              scenario.AlgorithmParameters.Items.Add(param);
+          }
+          reader.Read();
+        }
+      }
+      
+      if (isErrorPresent)
+        return null;
+      return scenario;
+    }
+
+    struct ValueEntry {
+      public double v1;
+      public double v2;
+    };
+
+    private void ParseDecimalMatrix(Model.DecimalMatrix matrix, XmlReader reader) {      
+      IList<ValueEntry> ventries = new List<ValueEntry>();
+      while (reader.Read()) {        
+        if (reader.Name == "param")
+          break;
+        if (reader.Name == "value") {
+          var val1 = Convert.ToDouble(reader.GetAttribute("v1"), CultureInfo.InvariantCulture.NumberFormat);
+          var val2 = Convert.ToDouble(reader.GetAttribute("v2"), CultureInfo.InvariantCulture.NumberFormat);
+          ventries.Add(new ValueEntry() { v1 = val1, v2 = val2 });          
+        }
+      }
+      double[][] mat = new double[ventries.Count][];
+      int i=0;
+      foreach (var entry in ventries) {
+        mat[i] = new double[2];
+        mat[i][0] = entry.v1;
+        mat[i][1] = entry.v2;
+        i++;
+      }
+      matrix.Value = mat;
+    }
+
+    private IList<Model.Parameter> ParseParameters(XmlReader reader) {
+      IList<Model.Parameter> parameters = new List<Model.Parameter>();
+      while (reader.Read()) {
+        if (reader.Name.EndsWith("Parameters"))
+          break;
+        // parse parameter
+        if (reader.Depth == 2 && reader.Name == "param" && reader.NodeType == XmlNodeType.Element) {
+          var param = new Model.Parameter();
+          var typeAtt = reader.GetAttribute("type");
+          param.Type = (Model.ParameterType)Enum.Parse(typeof(Model.ParameterType), typeAtt);
+          switch (param.Type) {
+            case Model.ParameterType.Boolean:
+              param.Value = new Model.BoolValue() { Name = reader.GetAttribute("name"), Value = Convert.ToBoolean(reader.GetAttribute("value")) };
+              break;
+            case Model.ParameterType.Integer:
+            case Model.ParameterType.Percent:
+            case Model.ParameterType.Decimal:
+              //TODO: Check which comma char is being used; enhance to use any
+              param.Value = new Model.DecimalValue() { Name = reader.GetAttribute("name"), Value = Convert.ToDouble(reader.GetAttribute("value"), CultureInfo.InvariantCulture.NumberFormat) };
+              break;            
+            case Model.ParameterType.DecimalMatrix:
+              var decMatrix = new Model.DecimalMatrix() { Name = reader.GetAttribute("name") };
+              ParseDecimalMatrix(decMatrix, reader);
+              param.Value = decMatrix;
+              break;
+            case Model.ParameterType.DecimalVector:
+              var decVec = new Model.DecimalVector() { Name = reader.GetAttribute("name") };
+              ParseDecimalVector(decVec, reader);
+              param.Value = decVec;
+              break;
+            case Model.ParameterType.Type:
+              var type = new Model.TypeValue() { Name = reader.GetAttribute("name") };
+              ParseType(type, reader);
+              param.Value = type;
+              break;
+            case Model.ParameterType.String:
+              param.Value = new Model.StringValue() { Name = reader.GetAttribute("name"), Value = reader.GetAttribute("value") };
+              break;
+            default:
+              Console.WriteLine("Unhandled model type: " + param.Type);
+              break;
+          }
+          parameters.Add(param);
+        }
+      }
+      return parameters;
+    }
+
+    private void ParseType(Model.TypeValue type, XmlReader reader) {
+      var choices = new List<string>();
+      string selected = null;
+      while (reader.Read()) {
+        if (reader.Name == "param")
+          break;
+        if (reader.Name == "choice") {
+          var choice = reader.GetAttribute("name");
+          if (reader.HasAttributes && Convert.ToBoolean(reader.GetAttribute("selected"))) {            
+            selected = choice;
+          }
+          choices.Add(choice);
+        }
+      }
+      type.Options = choices.ToArray();
+      type.Value = selected;
+    }
+
+    private void ParseDecimalVector(Model.DecimalVector decVec, XmlReader reader) {
+      var entries = new List<double>();
+      //IList<ValueEntry> ventries = new List<ValueEntry>();
+      while (reader.Read()) {
+        if (reader.Name == "param")
+          break;
+        if (reader.Name == "value") {
+          var val1 = Convert.ToDouble(reader.GetAttribute("v1"), CultureInfo.InvariantCulture.NumberFormat);
+          entries.Add(val1);
+        }
+      }
+      decVec.Value = entries.ToArray();      
+    }
+  }
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 8958)
@@ -130,7 +130,13 @@
       <HintPath>..\bin\HeuristicLab.Tracing-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="Microsoft.WindowsAzure.CloudDrive, Version=1.7.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL" />
+    <Reference Include="Microsoft.WindowsAzure.Configuration, Version=1.7.0.0, Culture=neutral, processorArchitecture=MSIL" />
+    <Reference Include="Microsoft.WindowsAzure.Diagnostics, Version=1.7.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL" />
+    <Reference Include="Microsoft.WindowsAzure.ServiceRuntime, Version=1.7.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL" />
+    <Reference Include="Microsoft.WindowsAzure.StorageClient, Version=1.7.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL" />
     <Reference Include="System" />
     <Reference Include="System.configuration" />
     <Reference Include="System.Core" />
+    <Reference Include="System.Data.Services.Client" />
     <Reference Include="System.Runtime.Serialization" />
     <Reference Include="System.ServiceModel" />
@@ -142,14 +148,16 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="HiveScenarioManagerOld.cs" />
-    <Compile Include="HiveMapper.cs" />
-    <Compile Include="HiveScenarioManager.cs" />
-    <Compile Include="HLMapper.cs" />
+    <Compile Include="Azure\DAL.cs" />
+    <Compile Include="HL\HiveScenarioManagerOld.cs" />
+    <Compile Include="HL\HiveMapper.cs" />
+    <Compile Include="HL\HiveScenarioManager.cs" />
+    <Compile Include="HL\HLMapper.cs" />
     <Compile Include="Interfaces\IControllerService.cs" />
+    <Compile Include="Interfaces\DAL.cs" />
     <Compile Include="Interfaces\IScenarioManager.cs" />
     <Compile Include="Model\ControllerModel.cs" />
     <Compile Include="PlaceholderControllerService.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="ScenarioParser.cs" />
+    <Compile Include="HL\ScenarioParser.cs" />
     <Compile Include="Utility.cs" />
   </ItemGroup>
@@ -157,4 +165,5 @@
     <WCFMetadata Include="Service References\" />
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 8958)
@@ -0,0 +1,30 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Services.Optimization.ControllerService.Interfaces {
+  public class StringEntry {
+    public string Key { get; set; }
+    public string Text { get; set; }    
+  };
+
+  public interface IScenarioDao {
+    bool Add(ScenarioEntity entity);
+    bool DeleteByName(string scenarioName);
+    ScenarioEntity FindByName(string scenarioName);
+    IEnumerable<ScenarioEntity> GetAllEntities();
+  }
+
+  public interface IBlobDao {
+    bool Add(StringEntry entry);
+    bool DeleteByKey(string entryKey);
+    StringEntry FindByKey(string entryKey);
+  }
+
+  public interface IDataAccessLayer {
+    IScenarioDao CreateScenarioDao();
+    IBlobDao CreateBlobDao();
+  }
+}
+
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 8958)
@@ -12,4 +12,7 @@
     [OperationContract]
     IEnumerable<OptimizationScenario> GetOptimizationScenarios();
+
+    [OperationContract]
+    IEnumerable<string> GetOptimizationScenarioNames();
 
     [OperationContract]
@@ -30,4 +33,10 @@
     [OperationContract]
     IList<Model.Run> GetJobResults(User user, string id);
+
+    [OperationContract]
+    bool AddHiveScenario(User user, string scenarioXml, string scenarioMapper);
+
+    [OperationContract]
+    bool DeleteHiveScenario(User user, string scenarioName);
   }
 }
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 8958)
@@ -12,4 +12,6 @@
     void DeleteJob(User user, string id);
     IList<Model.Run> GetJobResults(User user, string id);
+    bool AddScenario(User user, string scenarioName, string scenarioXml, string scenarioMapper);
+    bool DeleteScenario(User user, string scenarioName);
   }
 }
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 8958)
@@ -62,7 +62,8 @@
 
     public Model.OptimizationScenario GetOptimizationScenarioByName(string name) {
-      if (scenarios[0].Name == name)
-        return scenarios[0];
-      return null;
+      var scen = (from e in scenarios
+                  where e.Name == name
+                  select e).FirstOrDefault();      
+      return scen;
     }
 
@@ -89,4 +90,30 @@
       return hiveManager.GetJobResults(user, id);
     }
+
+
+    public bool AddHiveScenario(User user, string scenarioXml, string scenarioMapper) {
+      var scenario = parser.ParseScenarioFromXml(scenarioXml);
+      if (scenario == null) {
+        return false;
+      }      
+      var added = hiveManager.AddScenario(user, scenario.Name, scenarioXml, scenarioMapper);
+      if (added) 
+        scenarios.Add(scenario);
+      return added;
+    }
+
+    public bool DeleteHiveScenario(User user, string scenarioName) {
+      var scen = GetOptimizationScenarioByName(scenarioName);
+      if (scen != null) {
+        scenarios.Remove(scen);
+        return hiveManager.DeleteScenario(user, scenarioName);
+      }
+      return false;
+    }
+
+    public IEnumerable<string> GetOptimizationScenarioNames() {
+      return (from e in scenarios
+              select e.Name).AsEnumerable();      
+    }
   }
 }
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/AdminController.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/AdminController.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/AdminController.cs	(revision 8958)
@@ -0,0 +1,88 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+using System.Web.Mvc;
+using HeuristicLab.Services.Optimization.Web.Models;
+using System.IO;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Services.Optimization.ControllerService;
+using System.ServiceModel;
+using System.ServiceModel.Description;
+using System.Web.Security;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+
+namespace HeuristicLab.Services.Optimization.Web.Controllers
+{
+    [Authorize(Roles = "Web User")]
+    public class AdminController : Controller
+    {
+      public delegate T ControllerServiceDelegate<T>(IControllerService service);
+      public delegate void ControllerServiceDelegate(IControllerService service);
+
+      public T withControllerService<T>(ControllerServiceDelegate<T> del) {
+        using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {
+          var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
+          credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
+          credentialBehaviour.UserName.Password = Session["pw"] as string;
+          var controllerProxy = cf.CreateChannel();
+          return del(controllerProxy);
+        }
+      }
+
+      public void withControllerService(ControllerServiceDelegate del) {
+        using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {
+          var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
+          credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
+          credentialBehaviour.UserName.Password = Session["pw"] as string;
+          var controllerProxy = cf.CreateChannel();
+          del(controllerProxy);
+        }
+      }
+        //
+        // GET: /Admin/
+        [HttpGet]
+        public ActionResult Index()
+        {
+          var names = withControllerService<IEnumerable<string>>((service) => {            
+            User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+            return service.GetOptimizationScenarioNames();
+          });
+          return View(names);
+        }
+
+        [HttpPost]
+        public ActionResult AddScenario(UploadScenario newSecnario) {
+          StreamReader reader = new StreamReader(newSecnario.ScenarioMapper.InputStream);
+          string scenarioMapper = reader.ReadToEnd();
+
+          XmlDocument doc = new XmlDocument();
+          doc.Load(newSecnario.ScenarioXml.InputStream);
+          string scenarioXml;
+          using (var stringWriter = new StringWriter())
+          using (var xmlTextWriter = XmlWriter.Create(stringWriter)) {
+            doc.WriteTo(xmlTextWriter);
+            xmlTextWriter.Flush();
+            scenarioXml = stringWriter.GetStringBuilder().ToString();
+          }
+
+          var ok = withControllerService<bool>((service) => {
+            OptimizationModel model = new OptimizationModel();
+            User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+            return service.AddHiveScenario(u, scenarioXml, scenarioMapper);                        
+          });
+
+          return RedirectToAction("Index");
+        }
+
+        public ActionResult DeleteScenario(string id) {
+          withControllerService<bool>((service) => {            
+            User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+            return service.DeleteHiveScenario(u, id);
+          });
+          return RedirectToAction("Index");
+        }
+
+    }
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/HomeController.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/HomeController.cs	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/HomeController.cs	(revision 8958)
@@ -7,8 +7,6 @@
 namespace HeuristicLab.Services.Optimization.Web.Controllers {
   public class HomeController : Controller {
-    public ActionResult Index() {
-      ViewBag.Message = "Welcome to ASP.NET MVC!";
-
-      return View();
+    public ActionResult Index() {      
+      return RedirectToAction("Index", "Optimization");      
     }
 
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 8958)
@@ -97,4 +97,5 @@
   <ItemGroup>
     <Compile Include="Controllers\AccountController.cs" />
+    <Compile Include="Controllers\AdminController.cs" />
     <Compile Include="Controllers\HomeController.cs" />
     <Compile Include="Controllers\OptimizationController.cs" />
@@ -103,4 +104,5 @@
     </Compile>
     <Compile Include="Models\AccountModels.cs" />
+    <Compile Include="Models\AdminModels.cs" />
     <Compile Include="Models\OptimizationModels.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -257,4 +259,5 @@
       <SubType>Designer</SubType>
     </None>
+    <Content Include="Views\Admin\Index.cshtml" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/tsp.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/tsp.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/tsp.cs	(revision 8958)
@@ -0,0 +1,42 @@
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Services.Optimization.ControllerService.Model; 
+using HeuristicLab.Optimization;
+using HeuristicLab.Services.Optimization.ControllerService;
+using HeuristicLab.Algorithms.GeneticAlgorithm;
+using HeuristicLab.Problems.TravelingSalesman;
+public class TSPScenarioMapper : IScenarioMapper {
+  public void MapScenario(OptimizationScenario scenario, IAlgorithm algorithm) {
+    Console.WriteLine("Mapping scenario!");
+    var ga = algorithm as GeneticAlgorithm;
+    var problem = algorithm.Problem as TravelingSalesmanProblem;
+                  
+    problem.BestKnownQuality = HLMapper.ConvertToDoubleValue(scenario.InputParameters.FindByName("BestKnownQuality"));
+    problem.BestKnownSolution = HLMapper.ConvertToPermutation(scenario.InputParameters.FindByName("BestKnownSolution"));
+    problem.Coordinates = HLMapper.ConvertToDoubleMatrix(scenario.InputParameters.FindByName("Coordinates"));
+    var evalParam = HLMapper.GetStringValue(scenario.InputParameters.FindByName("EvaluatorParameter"));
+    if (evalParam == "HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator") {
+      problem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
+    }
+    else if (evalParam == "HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator") {
+      problem.EvaluatorParameter.Value = new TSPGeoPathEvaluator();
+    }
+    else {
+      problem.EvaluatorParameter.Value = new TSPEuclideanPathEvaluator();
+    }
+    problem.UseDistanceMatrix = HLMapper.ConvertToBoolValue(scenario.InputParameters.FindByName("UseDistanceMatrix"));
+    Console.WriteLine("Mapping algorithm...");
+    ga.Mutator = HLMapper.FindInItemSet<HeuristicLab.Optimization.IManipulator>(ga.MutatorParameter.ValidValues, scenario.AlgorithmParameters.FindByName("Mutator"));
+    ga.CrossoverParameter.Value = HLMapper.FindOperator<HeuristicLab.Optimization.ICrossover>(problem, scenario.AlgorithmParameters.FindByName("CrossoverParameter"));
+    ga.Elites = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("Elites"));
+    ga.MaximumGenerations = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("MaximumGenerations"));
+    ga.MutationProbability = HLMapper.ConvertToPercentValue(scenario.AlgorithmParameters.FindByName("MutationProbability"));                
+    ga.PopulationSize = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("PopulationSize"));
+    ga.Seed = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName("Seed"));
+    ga.Selector = HLMapper.FindInItemSet<HeuristicLab.Optimization.ISelector>(ga.SelectorParameter.ValidValues, scenario.AlgorithmParameters.FindByName("Selector"));
+    ga.SetSeedRandomly = HLMapper.ConvertToBoolValue(scenario.AlgorithmParameters.FindByName("SetSeedRandomly"));
+  }
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/AdminModels.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/AdminModels.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/AdminModels.cs	(revision 8958)
@@ -0,0 +1,26 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel.DataAnnotations;
+using System.Globalization;
+using System.Web.Mvc;
+using System.Web.Security;
+using System.Web;
+
+namespace HeuristicLab.Services.Optimization.Web.Models {
+  public class UploadScenario {
+    private HttpPostedFileBase scenarioMapper;
+
+    public HttpPostedFileBase ScenarioMapper {
+      get { return scenarioMapper; }
+      set { scenarioMapper = value; }
+    }
+
+    private HttpPostedFileBase scenarioXml;
+
+    public HttpPostedFileBase ScenarioXml {
+      get { return scenarioXml; }
+      set { scenarioXml = value; }
+    }
+
+  }
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Admin/Index.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Admin/Index.cshtml	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Admin/Index.cshtml	(revision 8958)
@@ -0,0 +1,42 @@
+﻿@model IEnumerable<string>
+
+@{
+    ViewBag.Title = "Index.cshtml";
+}
+
+<h2>Add scenarios</h2>
+
+@using (Html.BeginForm("AddScenario", "Admin", FormMethod.Post, new {enctype = "multipart/form-data"})) {
+  <fieldset>    
+    <label for="scenarioMapper">Scenario Mapper</label>
+    <input type="file" name="scenarioMapper" id="scenarioMapper" />
+    <label for="scenarioMapper">Scenario XML</label>
+    <input type="file" name="scenarioXml" id="scenarioXml" />
+    <input type="submit" value="Upload scenario" />
+  </fieldset>
+}
+
+<h2>Manage scenarios:</h2>
+@using (Html.BeginForm("DeleteScenario", "Admin", FormMethod.Post)) {    
+<table>
+      <thead>
+        <tr>
+          <td>Name</td>
+          <td>Delete</td>          
+        </tr>
+      </thead>
+      <tbody>
+      @foreach (var scen in Model) {
+        <tr>
+          <td>@scen</td>
+          <td>
+             <input type="hidden" value="@scen" name="id" />
+             <input type="submit" value="Delete" />       
+          </td>          
+       </tr>
+      }
+      </tbody>
+    </table>
+}
+
+
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/_Layout.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/_Layout.cshtml	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/_Layout.cshtml	(revision 8958)
@@ -19,4 +19,5 @@
             <nav>
                 <ul id="menu">
+                    <li>@Html.ActionLink("Admin", "Index", "Admin")</li>
                     <li>@Html.ActionLink("Home", "Index", "Home")</li>
                     <li>@Html.ActionLink("About", "About", "Home")</li>
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/WebRole.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/WebRole.cs	(revision 8956)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/WebRole.cs	(revision 8958)
@@ -7,8 +7,25 @@
 
 namespace HeuristicLab.Services.Optimization.Web {
+  public static class Constants {
+    public const string DiagnosticsConnectionString = "Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString";
+  }
+
   public class WebRole : RoleEntryPoint {
     public override bool OnStart() {
       // For information on handling configuration changes
-      // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
+      // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.      
+      try {
+        if (!String.IsNullOrEmpty(RoleEnvironment.GetConfigurationSettingValue(Constants.DiagnosticsConnectionString))) {
+          DiagnosticMonitorConfiguration dmc = DiagnosticMonitor.GetDefaultInitialConfiguration();
+          dmc.Logs.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
+          dmc.Logs.ScheduledTransferLogLevelFilter = LogLevel.Verbose;
+          DiagnosticMonitor.Start(Constants.DiagnosticsConnectionString, dmc);
+        }
+      }
+      catch (RoleEnvironmentException ex) {
+        // diagnostics connection string not in configuration
+        // -> diagnostics disabled
+        // nothing more to do
+      }
 
       return base.OnStart();
